//+-------------------------------------------------------------------------------------+
//|                                                                  Complex_Expert.mq4 |
//|                                                                           Scriptong |
//|                                                                                     |
//+-------------------------------------------------------------------------------------+
#property copyright "Scriptong"
#property link      "scriptong@mail.ru"

//---- input parameters
extern double    Lots        = 0.1;                          //   
extern int       TakeProfit = 0;       //   .  0,   
extern int       StopLoss = 0;           //   .  0,   
extern int       TrailingStop1 = 30;                                         // 
extern int       TrailingStop2 = 50;                        //  -
extern string    A1 = " ADX";
extern bool      UseADX = True;     // True,    ADX,  - 
extern int       ADXPeriod = 21;
extern int       ADXPrice = 0;                   // ,    ADX:
                                      // 0 - Close
                                      // 1 - Open
                                      // 2 - High
                                      // 3 - Low
                                      // 4 - Median Price
                                      // 5 - Typical Price
                                      // 6 - Weigthed Price 
extern string    A2 = "==========================";

extern string    A3 = " Bollinger Bands";
extern bool      UseBollinger = False;
extern int       BandsPeriod = 20;
extern int       BandsShift = 0;
extern int       BandsDeviation = 2;
extern int       BandsPrice = 0;
extern string    A4 = "==========================";

extern string    A5 = " CCI";
extern bool      UseCCI = False;
extern int       CCIPeriod = 14;
extern int       CCIPrice = 0;
extern int       CCIHighLevel = 100;
extern int       CCILowLevel = -100;
extern string    A6 = "==========================";

extern string    A7 = "  MA";
extern bool      UseCrossMA = False;
extern int       MAFastPeriod = 34;
extern int       MAFastPrice = 0;
extern int       MAFastMethod = 0;                                       //  MA:
                                                      // 0 - Simple MA
                                                      // 1 - Exponential MA
                                                      // 2 - Smoothed MA
                                                      // 3 - Linear weighted MA
extern int       MAFastShift = 0;
extern int       MASlowPeriod = 89;
extern int       MASlowPrice = 0;
extern int       MASlowMethod = 0;
extern int       MASlowShift = 0;
extern string    A8 = "==========================";

extern string    A9 = "  Parabolic SAR";
extern bool      UseSAR = False;
extern double    SARStep = 0.01;
extern double    SARMaximum = 0.03;
extern string    A10 = "==========================";

extern string    A11 = "  Standard Deviation";
extern bool      UseStDev = False;
extern int       StDevPeriod = 21;
extern int       StDevPrice = 0;
extern int       StDevMethod = 0;
extern int       StDevShift = 0;
extern string    A12 = "==========================";

extern string    A13 = "  MACD";
extern bool      UseMACD = False;
extern int       MACDFast = 12;
extern int       MACDSlow = 26;
extern int       MACDSignal = 9;
extern int       MACDPrice = 0;
extern string    A14 = "==========================";

extern string    A15 = "  DeMarker";
extern bool      UseDeMarker = False;
extern int       DMPeriod = 24;
extern double    DMHighLevel = 0.7;
extern double    DMLowLevel = 0.3;
extern string    A16 = "==========================";

extern string    A17 = "  Envelopes";
extern bool      UseEnvelopes = False;
extern int       EnvPeriod = 21;
extern int       EnvShift = 0;
extern int       EnvMethod = 0;
extern int       EnvPrice = 0;
extern double    EnvDeviation = 0.5;
extern string    A18 = "==========================";

extern string    A19 = "  Force Index";
extern bool      UseForceIndex = False;
extern int       FIPeriod = 13;
extern int       FIMethod = 0;
extern int       FIPrice = 0;
extern string    A20 = "==========================";

extern string    A21 = "  Momentum";
extern bool      UseMomentum = False;
extern int       MomPeriod = 14;
extern int       MomPrice = 0;
extern string    A22 = "==========================";

extern string    A23 = "  OsMA";
extern bool      UseOsMA = False;
extern int       OsMAFast = 12;
extern int       OsMASlow = 26;
extern int       OsMASignal = 9;
extern int       OsMAPrice = 0;
extern string    A24 = "==========================";

extern string    A25 = "  RSI";
extern bool      UseRSI = False;
extern int       RSIPeriod = 21;
extern int       RSIPrice = 0;
extern int       RSIHighLevel = 70;
extern int       RSILowLevel = 30;
extern string    A26 = "==========================";

extern string    A27 = "  RVI";
extern bool      UseRVI = False;
extern int       RVIPeriod = 21;
extern string    A28 = "==========================";

extern string    A29 = "  Stochastic";
extern bool      UseStochastic = False;
extern int       StochK = 5;
extern int       StochD = 3;
extern int       StochSlowing = 10;
extern int       StochPrice = 0;
extern int       StochMethod = 0;
extern string    A30 = "==========================";

extern string    A31 = "  Williams Percent Range";
extern bool      UseWPR = False;
extern int       WPRPeriod = 24;
extern double    WPRHighLevel = -20;
extern double    WPRLowLevel = -80;
extern string    A32 = "==========================";

extern string    A33 = "  Awesome";
extern bool      UseAO = False;
extern string    A34 = "==========================";

extern string    A35 = "  Accelerator/Decelerator";
extern bool      UseAC = False;
extern string    A36 = "==========================";

extern string    A37 = "  Fractals";
extern bool      UseFractals = False;
extern string    A38 = "==========================";

extern string    A39 = "  Alligator";
extern bool      UseAlligator = False;
extern int       JawPeriod = 13;
extern int       JawShift = 8;
extern int       TeethPeriod = 8;
extern int       TeethShift = 5;
extern int       LipsPeriod = 5;
extern int       LipsShift = 3;
extern int       AlligatorMethod = 2;
extern int       AlligatorPrice = 4;
extern string    A40 = "==========================";

extern string    A41 = "  Bill Williams MFI";
extern bool      UseBWMFI = False;
extern string    A42 = "==========================";

extern string    OpenOrderSound = "ok.wav";                   //    
extern int       MagicNumber = 17589 ;                                 
extern string    comment = "Complex_Expert";

bool Activate, FreeMarginAlert, FatalError;
double Tick, Spread, StopLevel, MinLot, MaxLot, LotStep;
datetime LastBar, LastBuySignal, LastSellSignal, LastMess;
int Signal, UseInd;
string Comm;


//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
int init()
  {
//----
   Activate = False;
// - 1 - ==      ========================================   
   Tick = MarketInfo(Symbol(), MODE_TICKSIZE);                         //      
   Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);                  //  
   StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);  //    
   MinLot = MarketInfo(Symbol(), MODE_MINLOT);    //    
   MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);   //    
   LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);          //    
// - 1 - ==   =============================================================

// - 2 - ==          =======   
   Lots = MathRound(Lots/LotStep)*LotStep; //     
   if(Lots < MinLot || Lots > MaxLot) //     MinLot    MaxLot
     {
      Comment(" Lots     !  !");
      return(0);
     }
// - 2 - ==   =============================================================

   UseInd = UseADX + UseBollinger + UseCCI + UseCrossMA + UseSAR + UseStDev + UseMACD +
            UseDeMarker + UseEnvelopes + UseForceIndex + UseMomentum + UseOsMA + UseRSI +
            UseRVI + UseStochastic + UseWPR + UseAO + UseAC + UseFractals + UseAlligator+
            UseBWMFI;
            
   Comm = "  :\n";
   if (UseADX) Comm = Comm + "ADX\n";            
   if (UseBollinger) Comm = Comm + "Bollinger Bands\n";            
   if (UseCCI) Comm = Comm + "CCI\n";            
   if (UseCrossMA) Comm = Comm + "CrossMA\n";            
   if (UseSAR) Comm = Comm + "Parabolic\n";            
   if (UseStDev) Comm = Comm + "StDev\n";            
   if (UseMACD) Comm = Comm + "MACD\n";            
   if (UseDeMarker) Comm = Comm + "DeMarker\n";            
   if (UseForceIndex) Comm = Comm + "ForceIndex\n";            
   if (UseMomentum) Comm = Comm + "Momentum\n";            
   if (UseOsMA) Comm = Comm + "OsMA\n";            
   if (UseRSI) Comm = Comm + "RSI\n";            
   if (UseRVI) Comm = Comm + "RVI\n";            
   if (UseStochastic) Comm = Comm + "Stochastic\n";            
   if (UseWPR) Comm = Comm + "WPR\n";            
   if (UseAO) Comm = Comm + "AO\n";            
   if (UseAC) Comm = Comm + "AC\n";            
   if (UseFractals) Comm = Comm + "Fractals\n";            
   if (UseAlligator) Comm = Comm + "Alligator\n";            
   if (UseBWMFI) Comm = Comm + "Bill Williams MFI\n";
   
   Comment(Comm);

   LastBuySignal = 0;
   LastSellSignal = 0;
   LastBar = 0;

   Activate = True; //    ,    
   
//----
   return(0);
  }

//+-------------------------------------------------------------------------------------+
//|                                                       |
//+-------------------------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
//----
   return(0);
}

//+--------------------------------------------------------------------------------------+
//|  -                                                          |
//| TrailingStop1 -       -  |
//| TrailingStop2 - .    -   |
//+--------------------------------------------------------------------------------------+
void TrailingStopDoubleLevel()
{
 for (int i = 0; i < OrdersTotal(); i++)
  if (OrderSelect(i, SELECT_BY_POS))
   if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() < 2)
   {
    if (!WaitForTradeContext()) break;
//  1.     -----------------------------------
    RefreshRates();
    double OpPrice = ND(OrderOpenPrice());   //      
    double SL = ND(OrderStopLoss());          //  -   
    double NBid = ND(Bid);
    double NAsk = ND(Ask);
//  1. -------------------------------------------------------------------------------

//  2.     -----------------------------------------
    if(OrderType() == OP_BUY)            
      if(SL >= OpPrice && TrailingStop2 != 0)           //     
        {
         if(NBid > ND(Tick*TrailingStop2+SL) &&  //  BID    TrailingStop2
            TrailingStop2 > StopLevel/Point)       //  TrailingStop2   
           if(WaitForTradeContext())                 //    
             if(!OrderModify(OrderTicket(), 0, 
                ND(NBid-TrailingStop2*Tick), OrderTakeProfit(), 0))         // 
               Print("    BUY.  .  ",
                     GetLastError(), ", : ", SL, ", : ", 
                     NBid-TrailingStop2*Tick);          //    
        }
//  2. -------------------------------------------------------------------------------

//  3.       -------------------------------------
       else  
        {    
         if(ND(OpPrice+TrailingStop1*Tick) < NBid &&      //  BID   
            TrailingStop1 > StopLevel/Point)     //  TrailingStop1   , 
           if(WaitForTradeContext())                                     //  
             if(!OrderModify(OrderTicket(), 0, OpPrice, 
                OrderTakeProfit(), 0))           // 
               Print("    BUY.  .  ", // 
                     GetLastError(), ", : ", SL, ", : ", OpPrice);//   
        } 
//  3. -------------------------------------------------------------------------------
     
//  4.     ----------------------------------------
    if(OrderType()==OP_SELL)                 //   
     if(OpPrice >= SL && SL != 0 && TrailingStop2 != 0) //     
       {
        if(TrailingStop2 > StopLevel/Point &&        // TrailingStop2   
           SL > ND(Tick*TrailingStop2+NAsk))  //  ASK    TrailingStop2 
          if(WaitForTradeContext())               //    
            if(!OrderModify(OrderTicket(), 0, ND(NAsk+TrailingStop2*Tick),
               OrderTakeProfit(), 0))                                       // 
              Print("    SELL.  .  ", 
                 GetLastError(), ", : ", SL, ", : ", NAsk+TrailingStop2*Tick);
       }
//  4. -------------------------------------------------------------------------------

//  5.       ------------------------------------
      else
       { 
        if(OpPrice > ND(NAsk+Tick*TrailingStop1) &&   //ASK    TrailingStop1
           TrailingStop1 > StopLevel/Point)                      //   StopLevel 
          if(WaitForTradeContext())                              //   
            if(!OrderModify(OrderTicket(), 0, OpPrice, OrderTakeProfit(), 0))//
              Print("    SELL.  .  ", 
                   GetLastError(), ", : ", SL, ", : ", OpPrice);
       }
//  5. -------------------------------------------------------------------------------
   }
  return(0); 
}

//+-------------------------------------------------------------------------------------+
//|                                                                        |
//|               Signal  ,  Buy                            |      
//|               Signal  ,  Sell                           |      
//+-------------------------------------------------------------------------------------+
void GetSignal()
{
 Signal = 0;
 
// - 1 - ==============  ADX ===================================================
 if (UseADX)
   {
    double PlusDI1 = iADX(Symbol(), 0, ADXPeriod, ADXPrice, MODE_PLUSDI, 1); 
    double MinusDI1 = iADX(Symbol(), 0, ADXPeriod, ADXPrice, MODE_MINUSDI, 1); 
    if (PlusDI1 > MinusDI1)                                                 // Buy Signal
      Signal++;
    if (PlusDI1 < MinusDI1)                                                // Sell Signal
      Signal--;
   } 
// - 1 - ======================   =========================================

// - 2 - ==============  Bollinger Bands =======================================
 if (UseBollinger)
   {
    double BandsUp = iBands(Symbol(), 0, BandsPeriod, BandsDeviation, BandsShift, 
                            BandsPrice, MODE_UPPER, 1); 
    double BandsDn = iBands(Symbol(), 0, BandsPeriod, BandsDeviation, BandsShift, 
                            BandsPrice, MODE_LOWER, 1); 
    if (Close[1] < BandsDn)                                                 // Buy Signal
      Signal++;
    if (Close[1] > BandsUp)                                                // Sell Signal
      Signal--;
   } 
// - 2 - ======================   =========================================

// - 3 - ==============  CCI ===================================================
 if (UseCCI)
   {
    double CCI1 = iCCI(Symbol(), 0, CCIPeriod, CCIPrice, 1); 
    double CCI2 = iCCI(Symbol(), 0, CCIPeriod, CCIPrice, 2); 
    if (CCI2 < CCILowLevel && CCI1 > CCILowLevel && CCI1 < CCIHighLevel)    // Buy Signal
      Signal++;
    if (CCI2 > CCIHighLevel && CCI1 < CCIHighLevel && CCI1 > CCILowLevel)  // Sell Signal
      Signal--;
   } 
// - 3 - ======================   =========================================

// - 4 - ==============   =============================================
 if (UseCrossMA)
   {
    double MAFast = iMA(Symbol(), 0, MAFastPeriod, MAFastShift, MAFastMethod, 
                         MAFastPrice, 1); 
    double MASlow = iMA(Symbol(), 0, MASlowPeriod, MASlowShift, MASlowMethod, 
                         MASlowPrice, 1); 
    if (MAFast > MASlow)                                                    // Buy Signal
      Signal++;
    if (MAFast < MASlow)                                                  // Sell Signal
      Signal--;
   } 
// - 4 - ======================   =========================================

// - 5 - ============== Parabolic SAR  =========================================
 if (UseSAR)
   {
    double SAR = iSAR(Symbol(), 0, SARStep, SARMaximum, 1); 
    if (SAR < Open[1])                                                      // Buy Signal
      Signal++;
    if (SAR > Open[1])                                                     // Sell Signal
      Signal--;
   } 
// - 5 - ======================   =========================================

// - 6 - ============== Standart Deviation  ====================================
 if (UseStDev)
   {
    double SD1 = iStdDev(Symbol(), 0, StDevPeriod, StDevShift, StDevMethod, 
                         StDevPrice, 1); 
    double SD2 = iStdDev(Symbol(), 0, StDevPeriod, StDevShift, StDevMethod, 
                         StDevPrice, 2); 
    if (SD1 > SD2)                                                          // Buy Signal
      Signal++;
    if (SD1 < SD2)                                                         // Sell Signal
      Signal--;
   } 
// - 6 - ======================   =========================================

// - 7 - ============== MACD  ==================================================
 if (UseMACD)
   {
    double MACDMain = iMACD(Symbol(), 0, MACDFast, MACDSlow, MACDSignal, MACDPrice,  
                         MODE_MAIN, 1); 
    double MACDSig = iMACD(Symbol(), 0, MACDFast, MACDSlow, MACDSignal, MACDPrice,
                         MODE_SIGNAL, 1); 
    if (MACDMain > MACDSig)                                              // Buy Signal
      Signal++;
    if (MACDMain < MACDSig)                                             // Sell Signal
      Signal--;
   } 
// - 7 - ======================   =========================================

// - 8 - ============== DeMarker  ==============================================
 if (UseDeMarker)
   {
    double DM1 = iDeMarker(Symbol(), 0, DMPeriod, 1); 
    double DM2 = iDeMarker(Symbol(), 0, DMPeriod, 2); 
    if (DM1 > DMLowLevel && DM2 < DMLowLevel && DM1 < DMHighLevel)          // Buy Signal
      Signal++;
    if (DM1 < DMHighLevel && DM2 > DMHighLevel && DM1 > DMLowLevel)        // Sell Signal
      Signal--;
   } 
// - 8 - ======================   =========================================

// - 9 - ============== Envelopes  =============================================
 if (UseEnvelopes)
   {
    double EnvUp = iEnvelopes(Symbol(), 0, EnvPeriod, EnvMethod, EnvShift, EnvPrice,
                              EnvDeviation, MODE_UPPER, 1); 
    double EnvDn = iEnvelopes(Symbol(), 0, EnvPeriod, EnvMethod, EnvShift, EnvPrice,
                              EnvDeviation, MODE_LOWER, 1); 
    if (Close[1] < EnvDn)                                                 // Buy Signal
      Signal++;
    if (Close[1] > EnvUp)                                                // Sell Signal
      Signal--;
   } 
// - 9 - ======================   =========================================

// - 10 - ============== Force Index  ==========================================
 if (UseForceIndex)
   {
    double FI = iForce(Symbol(), 0, FIPeriod, FIMethod, FIPrice, 1); 
    if (FI > 0)                                                             // Buy Signal
      Signal++;
    if (FI < 0)                                                            // Sell Signal
      Signal--;
   } 
// - 10 - ======================   ========================================

// - 11 - ============== Momentum  =============================================
 if (UseMomentum)
   {
    double Mom1 = iMomentum(Symbol(), 0, MomPeriod, MomPrice, 1); 
    double Mom2 = iMomentum(Symbol(), 0, MomPeriod, MomPrice, 2); 
    if (Mom1 > Mom2)                                                        // Buy Signal
      Signal++;
    if (Mom1 < Mom2)                                                       // Sell Signal
      Signal--;
   } 
// - 11 - ======================   ========================================

// - 12 - ============== OsMA  =================================================
 if (UseOsMA)
   {
    double OsMA = iOsMA(Symbol(), 0, OsMAFast, OsMASlow, OsMASignal, OsMAPrice, 1); 

    if (OsMA > 0)                                                           // Buy Signal
      Signal++;
    if (OsMA < 0)                                                          // Sell Signal
      Signal--;
   } 
// - 12 - ======================   ========================================

// - 13 - ==============  RSI ==================================================
 if (UseRSI)
   {
    double RSI1 = iRSI(Symbol(), 0, RSIPeriod, RSIPrice, 1); 
    double RSI2 = iRSI(Symbol(), 0, RSIPeriod, RSIPrice, 2); 
    if (RSI2 < RSILowLevel && RSI1 > RSILowLevel && RSI1 < RSIHighLevel)    // Buy Signal
      Signal++;
    if (RSI2 > RSIHighLevel && RSI1 < RSIHighLevel && RSI1 > RSILowLevel)  // Sell Signal
      Signal--;
   } 
// - 13 - ======================   ========================================

// - 14 - ==============  RVI ==================================================
 if (UseRVI)
   {
    double RVIM = iRVI(Symbol(), 0, RVIPeriod, MODE_MAIN, 1); 
    double RVIS = iRVI(Symbol(), 0, RVIPeriod, MODE_SIGNAL, 1); 
    if (RVIM > RVIS)                                                        // Buy Signal
      Signal++;
    if (RVIM < RVIS)                                                       // Sell Signal
      Signal--;
   } 
// - 14 - ======================   ========================================

// - 15 - ==============  Stochastic Oscillator ================================
 if (UseStochastic)
   {
    double StochM = iStochastic(Symbol(), 0, StochK, StochD, StochSlowing, StochMethod,
                                StochPrice, MODE_MAIN, 1); 
    double StochS = iStochastic(Symbol(), 0, StochK, StochD, StochSlowing, StochMethod,
                                StochPrice, MODE_SIGNAL, 1); 
    if (StochM > StochS)                                                    // Buy Signal
      Signal++;
    if (StochM < StochS)                                                   // Sell Signal
      Signal--;
   } 
// - 15 - ======================   ========================================

// - 16 - ==============  Williams Percent Range ===============================
 if (UseWPR)
   {
    double WPR1 = iWPR(Symbol(), 0, WPRPeriod, 1); 
    double WPR2 = iWPR(Symbol(), 0, WPRPeriod, 2); 
    if (WPR1 > WPRLowLevel && WPR2 < WPRLowLevel && WPR1 < WPRHighLevel)    // Buy Signal
      Signal++;
    if (WPR1 < WPRHighLevel && WPR2 > WPRHighLevel && WPR1 > WPRLowLevel)  // Sell Signal
      Signal--;
   } 
// - 16 - ======================   ========================================

// - 17 - ==============  Awesome Oscillator ===================================
 if (UseAO)
   {
    double AO1 = iAO(Symbol(), 0, 1); 
    double AO2 = iAO(Symbol(), 0, 2); 
    double AO3 = iAO(Symbol(), 0, 3); 
    double AO4 = iAO(Symbol(), 0, 4); 
    if (AO1 > 0 && AO3 > AO4 && AO2 < AO3 && AO1 > AO2)                     // Buy Signal
      Signal++;
    if (AO1 < 0 && AO3 < AO4 && AO2 > AO3 && AO1 < AO2)                    // Sell Signal
      Signal--;
   } 
// - 17 - ======================   ========================================

// - 18 - ==============  Accelerator/Decelerator Oscillator ===================
 if (UseAC)
   {
    double AC1 = iAC(Symbol(), 0, 1); 
    double AC2 = iAC(Symbol(), 0, 2); 
    double AC3 = iAC(Symbol(), 0, 3); 
    if (AC1 > 0 && AC3 < AC2 && AC2 < AC1)                                  // Buy Signal
      Signal++;
    if (AC1 < 0 && AC3 > AC2 && AC2 > AC1)                                 // Sell Signal
      Signal--;
   } 
// - 18 - ======================   ========================================

// - 19 - ==============  Fractals =============================================
 if (UseFractals)
   { 
    int i = 3;
    int DnN = 0, UpN = 0;
    double UpFr = 0, DnFr = 0;
    while (i < Bars && (UpFr == 0 || DnFr == 0))
      {
       if (iFractals(Symbol(), 0, MODE_UPPER, i) != 0)
         if (UpFr == 0)
           {
            UpFr = iFractals(Symbol(), 0, MODE_UPPER, i);
            UpN = i;
           } 
       if (iFractals(Symbol(), 0, MODE_LOWER, i) != 0)
         if (DnFr == 0)
           {
            DnFr = iFractals(Symbol(), 0, MODE_LOWER, i);
            DnN = i;
           } 
       i++;    
      }
    if (i < Bars)
      {
       int DnBit = iLowest(Symbol(), 0, MODE_LOW, DnN);
       int UpBit = iHighest(Symbol(), 0, MODE_HIGH, UpN);
       bool BitUp = False, BitDn = False;
       if (High[UpBit] > UpFr) BitUp = True;
       if (Low[DnBit] < DnFr) BitDn = True;
       if (BitUp && BitDn)
         {
          if (UpBit < DnBit)
            Signal++;
           else
            Signal--;
         }
        else
         {
          if (BitUp) Signal++;
          if (BitDn) Signal--;
         } 
      }  
   } 
// - 19 - ======================   ========================================

// - 20 - ==============  Alligator ============================================
 if (UseAlligator)
   {
    double Jaw = iAlligator(Symbol(), 0, JawPeriod, JawShift, TeethPeriod, TeethShift, 
                            LipsPeriod, LipsShift, AlligatorMethod, AlligatorPrice, 
                            MODE_GATORJAW, 0);
    double Teeth = iAlligator(Symbol(), 0, JawPeriod, JawShift, TeethPeriod, TeethShift, 
                              LipsPeriod, LipsShift, AlligatorMethod, AlligatorPrice, 
                              MODE_GATORTEETH, 0);
    double Lips = iAlligator(Symbol(), 0, JawPeriod, JawShift, TeethPeriod, TeethShift, 
                             LipsPeriod, LipsShift, AlligatorMethod, AlligatorPrice, 
                             MODE_GATORLIPS, 0);
    if (Jaw < Teeth && Teeth < Lips)                                        // Buy Signal
      Signal++;
    if (Jaw > Teeth && Teeth > Lips)                                       // Sell Signal
      Signal--;
   } 
// - 20 - ======================   ========================================

// - 21 - ==============  Bill Williams MFI ====================================
 if (UseBWMFI)
   {
    for (i = 2; i < Bars; i++)
      {
       double MFI = iBWMFI(Symbol(), 0, i);
       double MFI2 = iBWMFI(Symbol(), 0, i+1);
       if (MFI < MFI2 && Volume[i] > Volume[i+1])
         break;
      } 
    if (i < Bars)
      {
       if (Close[1] > High[i])
         Signal++;
       if (Close[1] < Low[i])    
         Signal--;
      }
   }      
// - 21 - ======================   ========================================

 if (UseInd == MathAbs(Signal))
   if (Signal > 0)
     {
      if (LastBuySignal <= LastSellSignal)
        LastBuySignal = Time[0];
     } 
    else
      if (LastSellSignal <= LastBuySignal)
        LastSellSignal = Time[0];

}  

//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
string ErrorToString(int Error)
{
 switch(Error)
   {
    case 2: return("  ,   ."); 
    case 5: return("    ,  ."); 
    case 6: return("   ,   ."); 
    case 64: return(" ,   .");
    case 132: return(" ."); 
    case 133: return(" ."); 
    case 149: return(" ."); 
   }
}
  
//+-------------------------------------------------------------------------------------+
//| ""                                                         |
//|    OpenOrder            |
//| :                                                                         |
//|   0 -                                                                      |
//|   1 -                                                                 |
//|   2 -   Price                                                         |
//|   3 -   SL                                                            |
//|   4 -   TP                                                            |
//|   5 -   Lots                                                          |
//+-------------------------------------------------------------------------------------+
int OpenOrderCorrect(int Type, double Price, double SL, double TP, 
                     bool Redefinition = True)
// Redefinition -  True     
//                 False -  
{
// - 1 - ==     ====================================
 if(AccountFreeMarginCheck(Symbol(), OP_BUY, Lots) <= 0 || GetLastError() == 134) 
  {
   if(!FreeMarginAlert)
    {
     Print("    . Free Margin = ", 
           AccountFreeMargin());
     FreeMarginAlert = True;
    } 
   return(5);  
  }
 FreeMarginAlert = False;  
// - 1 - ==   =============================================================

// - 2 - ==   Price, SL  TP    ====================   

 RefreshRates();
 switch (Type)
   {
    case OP_BUY: 
                string S = "BUY"; 
                if (MathAbs(Price-Ask)/Point > 3)
                  if (Redefinition) Price = NP(Ask);
                  else              return(2);
                if (ND(TP-Bid) <= StopLevel && TP != 0)
                  if (Redefinition) TP = NP(Bid+StopLevel+Tick);
                  else              return(4);
                if (ND(Bid-SL) <= StopLevel)
                  if (Redefinition) SL = NP(Bid-StopLevel-Tick);
                  else              return(3);
                break;
    case OP_SELL: 
                 S = "SELL"; 
                 if (MathAbs(Price-Bid)/Point > 3)
                   if (Redefinition) Price = NP(Bid);
                   else              return(2);
                 if (NP(Ask-TP) <= StopLevel) 
                   if (Redefinition) TP = NP(Ask-StopLevel-Tick);
                   else              return(4);
                 if (ND(SL-Ask) <= StopLevel && SL != 0)
                   if (Redefinition) SL = NP(Ask+StopLevel+Tick);
                   else              return(3);
                 break;
    case OP_BUYSTOP: 
                    S = "BUYSTOP";
                    if (ND(Price-Ask) <= StopLevel)
                      if (Redefinition) Price = NP(Ask+StopLevel+Tick);
                      else              return(2);
                    if (ND(TP-Price) <= StopLevel && TP != 0)
                      if (Redefinition) TP = NP(Price+StopLevel+Tick);
                      else              return(4);
                    if (ND(Price-SL) <= StopLevel)
                      if (Redefinition) SL = NP(Price-StopLevel-Tick);
                      else              return(3);
                    break;
    case OP_SELLSTOP: 
                     S = "SELLSTOP";
                     if (ND(Bid-Price) <= StopLevel)
                       if (Redefinition) Price = NP(Bid-StopLevel-Tick);
                       else              return(2);
                     if (ND(Price-TP) <= StopLevel)
                       if (Redefinition) TP = NP(Price-StopLevel-Tick);
                       else              return(4);
                     if (ND(SL-Price) <= StopLevel && SL != 0)
                       if (Redefinition) SL = NP(Price+StopLevel+Tick);
                       else              return(3);
                     break;
    case OP_BUYLIMIT: 
                     S = "BUYLIMIT";
                     if (ND(Ask-Price) <= StopLevel)
                      if (Redefinition) Price = NP(Ask-StopLevel-Tick);
                      else              return(2);
                     if (ND(TP-Price) <= StopLevel && TP != 0)
                       if (Redefinition) TP = NP(Price+StopLevel+Tick);
                       else              return(4);
                     if (ND(Price-SL) <= StopLevel)
                       if (Redefinition) SL = NP(Price-StopLevel-Tick);
                       else              return(3);
                     break;
    case OP_SELLLIMIT: 
                     S = "SELLLIMIT";
                     if (ND(Price - Bid) <= StopLevel) 
                       if (Redefinition) Price = NP(Bid+StopLevel+Tick);
                       else              return(2);
                     if (ND(Price-TP) <= StopLevel)
                       if (Redefinition) TP = NP(Price-StopLevel-Tick);
                       else              return(4);
                     if (ND(SL-Price) <= StopLevel && SL != 0)
                       if (Redefinition) SL = NP(Price+StopLevel+Tick);
                       else              return(3);
                     break;
   }
// - 2 - ==   =============================================================
 
// - 3 - ==       =================================   
 if(WaitForTradeContext())  //    
   {  
    Comment("     ", S, " ...");
    int ticket=OrderSend(Symbol(), Type, Lots, Price, 3, 
               SL, TP, comment, MagicNumber, 0);//  
    //     
    if(ticket<0)
      {
       int Error = GetLastError();
       if(Error == 2 || Error == 5 || Error == 6 || Error == 64 
          || Error == 132 || Error == 133 || Error == 149)     //   
         {
          Comment("     . . "+
                   ErrorToString(Error)+"  !");
          FatalError = True;
         }
        else
         Comment("   ", S, ": ", Error);       //  
         
       return(1);
      }
    // ---------------------------------------------
    
    //      
    Comment(" ", S, "  !"); 
    PlaySound(OpenOrderSound); 
    return(0); 
    // ------------------------
   }
  else
   {
    Comment("     !");
    return(1);  
   } 
// - 3 - ==   =============================================================  
}

//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double ND(double A)
{
 return(NormalizeDouble(A, Digits));
}  

//+-------------------------------------------------------------------------------------+
//|                                                |
//+-------------------------------------------------------------------------------------+
double NP(double A)
{
 return(MathFloor(A/Tick)*Tick);
}  

//+-------------------------------------------------------------------------------------+
//|   .   ,   True,  - False    |
//+-------------------------------------------------------------------------------------+  
bool WaitForTradeContext()
{
 int P = 0;
 //  ""
 while(IsTradeContextBusy() && P < 5)
   {
    P++;
    Sleep(1000);
   }
 // -------------  
 if(P == 5)
   return(False);
 return(True);    
}

//+-------------------------------------------------------------------------------------+
//|    "if-else"                                                 |
//+-------------------------------------------------------------------------------------+
double IF(bool Condition, double IfTrue, double IfFalse)
{
 if (Condition) return(IfTrue);    //   ,    IfTrue
 else           return(IfFalse);    //   ,    IfFalse
}  

//+-------------------------------------------------------------------------------------+
//|     Type.     ,  1.             |
//|   ,   2.    0.              |
//+-------------------------------------------------------------------------------------+
int CheckOrdersReal(int Type)
{
 for (int i = OrdersTotal()-1; i >= 0; i--)
   if(OrderSelect(i, SELECT_BY_POS))
     if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber 
        && OrderType() < 2)                                       //  "" 
       if(OrderType() == Type)                                  //    Type
         {
          if (WaitForTradeContext())  
            {
             if(Type == OP_BUY)
               double Pr = ND(MarketInfo(Symbol(), MODE_BID));
              else
               Pr = ND(MarketInfo(Symbol(), MODE_ASK));
             if (!OrderClose(OrderTicket(), OrderLots(), Pr, 3))//    
              return(1);                                 //    -  1
            }  
           else
            return(1);// 1,       
         }
        else
         return(2);          //  2,   ,  
 return(0);                                                   //   ,   0
}  

//+-------------------------------------------------------------------------------------+
//|  START                                                               |
//+-------------------------------------------------------------------------------------+
int start()
  {
// - 1 -  ==    ? ===========================================
   if (!Activate || FatalError)             //   ,  
    return(0);           //  init         
// - 1 -  ==   ============================================================
   if (LastMess + 300 < TimeCurrent())
     Comment(Comm);
   TrailingStopDoubleLevel();
// - 2 -  ==     ==============================================
   if (LastBar == Time[0])     //       
     return(0);                         //   ,      
// - 2 -  ==   ============================================================

// - 3 - ==      ========================================
   Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);                 //  
   StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);  //   
// - 3 -  ==   ============================================================
     
// - 4 - ==    =====================================================
   GetSignal();
// - 4 -  ==   ============================================================
   
   double Price = 0;
   int Type = -1;
   
// - 5 - ================   BUY =========================================
   if (LastBuySignal == Time[0])
     {
      int Res = CheckOrdersReal(OP_SELL);
      RefreshRates();
      if (Res == 0)                                          //    
        {                                               
         Price = ND(Ask);
         double TP = NP(IF(TakeProfit == 0, 0, Price + TakeProfit*Tick));
         double SL = NP(IF(StopLoss == 0, 0, Price - StopLoss*Tick));
         Type = OP_BUY;
        }                    
      if (Res == 1) return(0);              //     
     }
// - 5 - ======================   =========================================
     
// - 6 - ============   SELL ============================================
   if (LastSellSignal == Time[0])
     {
      Res = CheckOrdersReal(OP_BUY);
      if (Res == 0)                                               //    
        {               
         RefreshRates();
         Price = ND(Bid);
         TP = ND(IF(TakeProfit == 0, 0, Price - TakeProfit*Tick));
         SL = ND(IF(StopLoss == 0, 0, Price + StopLoss*Tick));
         Type = OP_SELL;
        }                    
      if (Res == 1) return(0);              //     
     }
// - 6 - ======================   =========================================

   if (Type >= 0)
     if (OpenOrderCorrect(Type, Price, SL, TP) > 0)   
        return(0);                                    
        
   LastBar = Time[0];     

   return(0);
  }
//+------------------------------------------------------------------+  